//+------------------------------------------------------------------+
//|                                              Body_ATR_Levels.mq4 |
//|                                       Copyright @ Dariusz Surdel |
//|                                   http://www.Fx-NVATC.comeze.com |
//+------------------------------------------------------------------+
#property copyright "Copyright @ Dariusz Surdel"
#property link      "http://www.Fx-NVATC.comeze.com"

#property indicator_chart_window

extern int Bars_For_ATR = 5;
extern color Color = Yellow;
extern int Width = 2; 
extern int Style = 0; 
extern bool Back = true;
extern color Open_Price_Color = Blue;
extern int Open_Price_Width = 0; 
extern int Open_Price_Style = 2; 
extern bool Open_Price_Back = true;
extern bool Show_Labels = true;
extern int Label_Offset = 10;
extern int Label_Font_Size = 11;
extern int Line_Left_Offset = 9;
extern bool Show_Price_Line = true;
extern color Price_Line_COLOR = Snow;
extern color Price_TP_Lines_Color = PaleGreen;
extern bool Price_Line_Ray = false;
extern int Price_Line_Style = 4;
extern int Price_Line_Width = 0;
extern bool SwitchOn_Custom_TP = false;
extern int Custom_TP_Pips = 27;

double HighestOpen,HighestClose,LowestOpen,LowestClose,HighestV,LowestV,Average,H4t,L4t,vPoint,
       Day_High1,Day_Low1,Day_Open1,Day_Close1,Day_High2,Day_Low2,Day_Open2,Day_Close2,Price1,Price2;
datetime thefuture;
int Tf;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  ObjectCreate("Price_Line",OBJ_TREND,0, 0,0, 0,0, 0,0);  
  ObjectCreate("Price_Line_Long_TP",OBJ_TREND,0, 0,0, 0,0, 0,0);
  ObjectCreate("Price_Line_Short_TP",OBJ_TREND,0, 0,0, 0,0, 0,0);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("H4tatr line");
   ObjectDelete("L4tatr line");
   ObjectDelete("L4tatr label");
   ObjectDelete("H4tatr label");
   ObjectDelete("H4tatr_line_Label"); 
  ObjectDelete("Price_Line");  
  ObjectDelete("Price_Line_Long_TP");
  ObjectDelete("Price_Line_Short_TP");    
  ObjectDelete("Open_Price_Line");
       
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
if(Digits==3 || Digits==5)
  {vPoint = Point*10;}
   else 
      {vPoint = Point;}
 Tf=0;     
     
HighestOpen=Open[iHighest(NULL,Tf,MODE_OPEN,Bars_For_ATR,1)];
HighestClose=Close[iHighest(NULL,Tf,MODE_CLOSE,Bars_For_ATR,1)];
LowestOpen=Open[iLowest(NULL,Tf,MODE_OPEN,Bars_For_ATR,1)];
LowestClose=Close[iLowest(NULL,Tf,MODE_CLOSE,Bars_For_ATR,1)];
if(HighestOpen>HighestClose) {HighestV=HighestOpen;}
if(HighestOpen<=HighestClose) {HighestV=HighestClose;}
if(LowestOpen<=LowestClose) {LowestV=LowestOpen;}
if(LowestOpen>LowestClose) {LowestV=LowestClose;}
Average=(HighestV-LowestV)/2;
H4t=iOpen(NULL,Tf,0)+Average;
L4t=iOpen(NULL,Tf,0)-Average;
thefuture=iTime(Symbol(),Tf,0)+31536000;
   
   ObjectDelete("H4tatr line");

     ObjectCreate("H4tatr line",OBJ_TREND,0,0,0);
     ObjectSet("H4tatr line",OBJPROP_PRICE1,H4t);  
     ObjectSet("H4tatr line",OBJPROP_PRICE2,H4t);
     ObjectSet("H4tatr line",OBJPROP_TIME1,Time[Line_Left_Offset]);
     ObjectSet("H4tatr line",OBJPROP_TIME2,thefuture);               
     ObjectSet("H4tatr line",OBJPROP_COLOR,Color);
     ObjectSet("H4tatr line",OBJPROP_WIDTH,Width);
     ObjectSet("H4tatr line",OBJPROP_STYLE,Style); 
     ObjectSet("H4tatr line",OBJPROP_BACK,Back);         

   ObjectDelete("L4tatr line");
     ObjectCreate("L4tatr line",OBJ_TREND,0,0,0);
     ObjectSet("L4tatr line",OBJPROP_PRICE1,L4t);
     ObjectSet("L4tatr line",OBJPROP_PRICE2,L4t); 
     ObjectSet("L4tatr line",OBJPROP_TIME1,Time[Line_Left_Offset]);
     ObjectSet("L4tatr line",OBJPROP_TIME2,thefuture);                   
     ObjectSet("L4tatr line",OBJPROP_COLOR,Color);
     ObjectSet("L4tatr line",OBJPROP_WIDTH,Width);
     ObjectSet("L4tatr line",OBJPROP_STYLE,Style); 
     ObjectSet("L4tatr line",OBJPROP_BACK,Back);  
     
   ObjectDelete("Open_Price_Line");  
     ObjectCreate("Open_Price_Line",OBJ_TREND,0, 0,0, 0,0, 0,0);
     ObjectSet("Open_Price_Line",OBJPROP_PRICE1,iOpen(NULL,Tf,0));
     ObjectSet("Open_Price_Line",OBJPROP_PRICE2,iOpen(NULL,Tf,0)); 
     ObjectSet("Open_Price_Line",OBJPROP_TIME1,Time[Line_Left_Offset]);
     ObjectSet("Open_Price_Line",OBJPROP_TIME2,thefuture);                   
     ObjectSet("Open_Price_Line",OBJPROP_COLOR,Open_Price_Color);
     ObjectSet("Open_Price_Line",OBJPROP_WIDTH,Open_Price_Width);
     ObjectSet("Open_Price_Line",OBJPROP_STYLE,Open_Price_Style); 
     ObjectSet("Open_Price_Line",OBJPROP_BACK,Open_Price_Back);     
     
if(Show_Labels==true)
  {
       // ObjectCreate(labelname, OBJ_TEXT, 0, MathMin(Time[BarForLabels], startofday + 2*Period()*60), (H4t-L4t)2);
   ObjectDelete("H4tatr_line_Label");
   ObjectCreate("H4tatr_line_Label",OBJ_TEXT,0, iTime(NULL,0,0) + Label_Offset*Period()*60,iOpen(NULL,Tf,0));   
   ObjectSetText("H4tatr_line_Label","Body_ATR("+Bars_For_ATR+"): "+DoubleToStr(Average/vPoint,1)+" Pips", Label_Font_Size, "Berlin Sans FB", Color);
   ObjectSet("H4tatr_line_Label",OBJPROP_BACK,false);
   
   }
    

  if(Show_Price_Line==true)
    {
  ObjectDelete("Price_Line");
  ObjectCreate("Price_Line",OBJ_TREND,0, 0,0, 0,0, 0,0);   
  ObjectSet("Price_Line",OBJPROP_PRICE1,Bid);
  ObjectSet("Price_Line",OBJPROP_PRICE2,Bid);
  ObjectSet("Price_Line",OBJPROP_TIME1,Time[Line_Left_Offset]);
  ObjectSet("Price_Line",OBJPROP_TIME2,thefuture); 
  ObjectSet("Price_Line",OBJPROP_COLOR,Price_Line_COLOR);
  ObjectSet("Price_Line",OBJPROP_STYLE,Price_Line_Style);
  ObjectSet("Price_Line",OBJPROP_WIDTH,Price_Line_Width);
  ObjectSet("Price_Line",OBJPROP_BACK,false);
  ObjectSet("Price_Line",OBJPROP_RAY,Price_Line_Ray);  
  
  if(SwitchOn_Custom_TP==true)
  {
  Average=Custom_TP_Pips*vPoint;
  }
  
  ObjectDelete("Price_Line_Long_TP");
  ObjectCreate("Price_Line_Long_TP",OBJ_TREND,0, 0,0, 0,0, 0,0);   
  ObjectSet("Price_Line_Long_TP",OBJPROP_PRICE1,Bid+Average);
  ObjectSet("Price_Line_Long_TP",OBJPROP_PRICE2,Bid+Average);
  ObjectSet("Price_Line_Long_TP",OBJPROP_TIME1,Time[Line_Left_Offset]);
  ObjectSet("Price_Line_Long_TP",OBJPROP_TIME2,thefuture); 
  ObjectSet("Price_Line_Long_TP",OBJPROP_COLOR,Price_TP_Lines_Color);
  ObjectSet("Price_Line_Long_TP",OBJPROP_STYLE,Price_Line_Style);
  ObjectSet("Price_Line_Long_TP",OBJPROP_WIDTH,Price_Line_Width);
  ObjectSet("Price_Line_Long_TP",OBJPROP_BACK,false);
  ObjectSet("Price_Line_Long_TP",OBJPROP_RAY,Price_Line_Ray);
  
  ObjectDelete("Price_Line_Short_TP");
  ObjectCreate("Price_Line_Short_TP",OBJ_TREND,0, 0,0, 0,0, 0,0);   
  ObjectSet("Price_Line_Short_TP",OBJPROP_PRICE1,Ask-Average);
  ObjectSet("Price_Line_Short_TP",OBJPROP_PRICE2,Ask-Average);
  ObjectSet("Price_Line_Short_TP",OBJPROP_TIME1,Time[Line_Left_Offset]);
  ObjectSet("Price_Line_Short_TP",OBJPROP_TIME2,thefuture); 
  ObjectSet("Price_Line_Short_TP",OBJPROP_COLOR,Price_TP_Lines_Color);
  ObjectSet("Price_Line_Short_TP",OBJPROP_STYLE,Price_Line_Style);
  ObjectSet("Price_Line_Short_TP",OBJPROP_WIDTH,Price_Line_Width);
  ObjectSet("Price_Line_Short_TP",OBJPROP_BACK,false);
  ObjectSet("Price_Line_Short_TP",OBJPROP_RAY,Price_Line_Ray);   
  
   }  

    
   return(0);
  }
//+------------------------------------------------------------------+